  ;--------------------------------------------
  ; sprintf conversion macros
  ;--------------------------------------------
  ; ************************************
  ; Return a register size in BYTES or *
  ; 0 if the arguent is not a register *
  ; ************************************
  regsize MACRO item
    LOCAL rv,ln
    rv = 0
    ln SIZESTR <item>
  
    IF ln EQ 2
      goto two
    ELSEIF ln EQ 3
      goto three
    ELSEIF ln EQ 4
      goto four
    ELSEIF ln EQ 5
      goto five
    ELSEIF ln EQ 6
      goto six
    ELSEIF ln EQ 8
      goto eight
    ELSE
      goto notreg
    ENDIF
  
  :two
    for arg,<al,ah,bl,bh,cl,ch,dl,dh>
      IFIDNI <arg>,<item>
        rv = 1
        EXITM
      ENDIF
    ENDM
    IF rv NE 0
      EXITM %rv
    ENDIF
  
    for arg,<ax,bx,cx,dx,sp,bp,si,di>
      IFIDNI <arg>,<item>
        rv = 2
        EXITM
      ENDIF
    ENDM
    IF rv NE 0
      EXITM %rv
    ENDIF
    goto notreg
  
  :three
    for arg,<eax,ebx,ecx,edx,esp,ebp,esi,edi>
      IFIDNI <arg>,<item>
        rv = 4
        EXITM
      ENDIF
    ENDM
    IF rv NE 0
      EXITM %rv
    ENDIF
  
    for arg,<st0,st1,st2,st3,st4,st5,st6,st7>
      IFIDNI <arg>,<item>
        rv = 10
        EXITM
      ENDIF
    ENDM
    IF rv NE 0
      EXITM %rv
    ENDIF
  
    for arg,<mm0,mm1,mm2,mm3,mm4,mm5,mm6,mm7>
      IFIDNI <arg>,<item>
        rv = 8
        EXITM
      ENDIF
    ENDM
    IF rv NE 0
      EXITM %rv
    ENDIF
    goto notreg
  
  :four
    for arg,<xmm0,xmm1,xmm2,xmm3,xmm4,xmm5,xmm6,xmm7>
      IFIDNI <arg>,<item>
        rv = 16
        EXITM
      ENDIF
    ENDM
    IF rv NE 0
      EXITM %rv
    ENDIF
    goto notreg
  
  :five
    for arg,<mm(0),mm(1),mm(2),mm(3),mm(4),mm(5),mm(6),mm(7)>
      IFIDNI <arg>,<item>
        rv = 8
        EXITM
      ENDIF
    ENDM
    IF rv NE 0
      EXITM %rv
    ENDIF
  
    for arg,<st(0),st(1),st(2),st(3),st(4),st(5),st(6),st(7)>
      IFIDNI <arg>,<item>
        rv = 10
        EXITM
      ENDIF
    ENDM
    IF rv NE 0
      EXITM %rv
    ENDIF
    goto notreg
  
  :six
    for arg,<xmm(0),xmm(1),xmm(2),xmm(3),xmm(4),xmm(5),xmm(6),xmm(7)>
      IFIDNI <arg>,<item>
        rv = 16
        EXITM
      ENDIF
    ENDM
    IF rv NE 0
      EXITM %rv
    ENDIF
    
  :eight
    for arg,<edx::eax,ecx::ebx>
      IFIDNI <arg>,<item>
        rv = 8
        EXITM
      ENDIF
    ENDM
    IF rv NE 0
      EXITM %rv
    ENDIF  
  
  :notreg
    EXITM %rv
  ENDM
  ;---------------------------------------------------
  issize MACRO var:req, bytes:req
      LOCAL rv
      rv = regsize(var) 
      IFE rv ; if not a register use SIZE 
          IF SIZE var EQ bytes
              EXITM <1>
          ELSE
              EXITM <0>
          ENDIF
      ELSE   ; it's a register       
          IF rv EQ bytes
              EXITM <1>        
          ELSE
              EXITM <0>
          ENDIF    
      ENDIF
  ENDM
  ; ----------------------------------------------
  isregister MACRO var:req
      IF regsize(var)
          EXITM <1>
      ELSE
          EXITM <0>
      ENDIF    
  ENDM    
  ; ----------------------------------------------
  ubyte$ MACRO ubytevalue:req
      ;; unsigned byte
      LOCAL buffer, ubtmp
      .data?
          ubtmp  BYTE ?
          buffer BYTE 4 dup(?)
      IFNDEF ubfmt    
      .data    
          ubfmt  BYTE "%hhu", 0
      ENDIF    
      .code
          IFE issize(ubytevalue, 1)
              echo ----------------------
              echo ubyte$ - requires BYTE
              echo ----------------------
              .ERR
          ENDIF               
          mov    buffer[0], 0
          IF isregister(ubytevalue)
              mov   ubtmp, ubytevalue
              movzx eax, ubtmp
          ELSE
              mov   al, ubytevalue
              movzx eax, al
          ENDIF    
          invoke crt_sprintf, ADDR buffer, ADDR ubfmt, eax
          EXITM <OFFSET buffer>
  ENDM
  ; ----------------------------------------------
  sbyte$ MACRO sbytevalue:req
      ;; signed byte
      LOCAL buffer, sbtmp
      .data?
          sbtmp  SBYTE ?
          buffer BYTE  8 dup(?)
      IFNDEF sbfmt     
      .data    
          sbfmt  BYTE "%hhd", 0
      ENDIF    
      .code
          IFE issize(sbytevalue, 1)
              echo -----------------------
              echo sbyte$ - requires SBYTE
              echo -----------------------
              .ERR
          ENDIF               
          mov    buffer[0], 0
          IF isregister(sbytevalue)
              mov   sbtmp, sbytevalue
              movsx eax, sbtmp
          ELSE     
              mov   al, sbytevalue
              movsx eax, al
          ENDIF    
          invoke crt_sprintf, ADDR buffer, ADDR sbfmt, eax
          EXITM <OFFSET buffer>
  ENDM
  ; ----------------------------------------------
  xbyte$ MACRO xbytevalue:req
      ;; unsigned hex byte
      LOCAL buffer, xbtmp
      .data?
          xbtmp  BYTE ?
          buffer BYTE 4 dup(?)
      IFNDEF xbfmt    
      .data    
          xbfmt  BYTE "%hhX", 0
      ENDIF    
      .code
          IFE issize(xbytevalue, 1)
              echo ----------------------
              echo xbyte$ - requires BYTE
              echo ----------------------
              .ERR
          ENDIF                
          mov buffer[0], 0
          IF isregister(xbytevalue)
              mov   xbtmp, xbytevalue
              movzx eax, xbtmp
          ELSE
              mov   al, xbytevalue
              movzx eax, al
          ENDIF    
          invoke crt_sprintf, ADDR buffer, ADDR xbfmt, eax 
          EXITM <OFFSET buffer>
  ENDM
  ; ----------------------------------------------
  uword$ MACRO uwordvalue:req
      ;; unsigned word
      LOCAL buffer, uwtmp
      .data?
          uwtmp  WORD ?
          buffer BYTE 8 dup(?)
      IFNDEF uwfmt    
      .data    
          uwfmt  BYTE "%hu", 0
      ENDIF    
      .code
          IFE issize(uwordvalue, 2)
              echo ----------------------
              echo uword$ - requires WORD
              echo ----------------------
              .ERR
          ENDIF            
          mov   buffer[0], 0
          IF isregister(uwordvalue)
              mov   uwtmp, uwordvalue
              movzx eax, uwtmp
          ELSE       
              mov   ax, uwordvalue
              movzx eax, ax
          ENDIF    
          invoke crt_sprintf, ADDR buffer, ADDR uwfmt, eax
          EXITM <OFFSET buffer>
  ENDM
  ; ----------------------------------------------
  sword$ MACRO swordvalue:req
      ;; signed word
      LOCAL buffer, swtmp
      .data?
          swtmp  SWORD ? 
          buffer BYTE  8 dup(?)
      IFNDEF swfmt    
      .data    
          swfmt  BYTE "%hd", 0
      ENDIF    
      .code
          IFE issize(swordvalue, 2)
              echo -----------------------
              echo sword$ - requires SWORD
              echo -----------------------
              .ERR
          ENDIF            
          mov   buffer[0], 0
          IF isregister(swordvalue)
              mov   swtmp, swordvalue
              movsx eax, swtmp
          ELSE    
              mov   ax, swordvalue
              movsx eax, ax
          ENDIF    
          invoke crt_sprintf, ADDR buffer, ADDR swfmt, eax
          EXITM <OFFSET buffer>
  ENDM
  ; ----------------------------------------------
  xword$ MACRO xwordvalue:req
      ;; unsigned hex word
      LOCAL buffer, xwtmp
      .data?
          xwtmp  WORD ?
          buffer BYTE 8 dup(?)
      IFNDEF xwfmt    
      .data    
          xwfmt  BYTE "%hX", 0
      ENDIF    
      .code
          IFE issize(xwordvalue, 2)
              echo ----------------------
              echo xword$ - requires WORD
              echo ----------------------
              .ERR
          ENDIF        
          mov   buffer[0], 0
          IF isregister(xwordvalue)
              mov   xwtmp, xwordvalue
              movzx eax, xwtmp
          ELSE               
              mov   ax, xwordvalue
              movzx eax, ax
          ENDIF    
          invoke crt_sprintf, ADDR buffer, ADDR xwfmt, eax
          EXITM <OFFSET buffer>
  ENDM
  ; ----------------------------------------------
  udword$ MACRO udwordvalue:req
      ;; unsigned dword
      LOCAL buffer
      .data?
          buffer BYTE  12 dup(?)
      IFNDEF udfmt    
      .data    
          udfmt  BYTE "%lu", 0
      ENDIF    
      .code
          IFE issize(udwordvalue, 4)
              echo ------------------------
              echo udword$ - requires DWORD
              echo ------------------------
              .ERR
          ENDIF    
          mov    buffer[0], 0
          invoke crt_sprintf, ADDR buffer, ADDR udfmt, udwordvalue
          EXITM <OFFSET buffer>
  ENDM
  ; ----------------------------------------------
  sdword$ MACRO sdwordvalue:req
      ;; signed dword
      LOCAL buffer
      .data?
           buffer BYTE   12 dup(?)
      IFNDEF sdfmt    
      .data    
          sdfmt BYTE "%ld", 0
      ENDIF    
      .code
          IFE issize(sdwordvalue, 4)
              echo -------------------------
              echo sdword$ - requires SDWORD
              echo -------------------------
              .ERR
          ENDIF        
          mov    buffer[0], 0
          invoke crt_sprintf, ADDR buffer, ADDR sdfmt, sdwordvalue
          EXITM <OFFSET buffer>
  ENDM
  ; ----------------------------------------------
  xdword$ MACRO xdwordvalue:req
      ;; unsigned hex dword
      LOCAL buffer
      .data?
          buffer BYTE  12 dup(?)
      IFNDEF xdfmt    
      .data    
          xdfmt BYTE "%lX", 0
      ENDIF    
      .code
          IFE issize(xdwordvalue, 4)
              echo ------------------------
              echo xdword$ - requires DWORD
              echo ------------------------
              .ERR
          ENDIF        
          mov    buffer[0], 0
          invoke crt_sprintf, ADDR buffer, ADDR xdfmt, xdwordvalue 
          EXITM <OFFSET buffer>
  ENDM
  ; ----------------------------------------------
  uqword$ MACRO uqwordvalue:req
      ;; unsigned qword
      LOCAL buffer
      .data?
          buffer BYTE 24 dup(?)
      IFNDEF uqwfmt    
      .data    
          uqwfmt BYTE "%I64u", 0
      ENDIF    
      .code
          IFE issize(uqwordvalue, 8)
              echo ------------------------
              echo uqword$ - requires QWORD
              echo ------------------------
              .ERR
          ENDIF        
          mov    buffer[0], 0
          invoke crt_sprintf, ADDR buffer, ADDR uqwfmt, uqwordvalue
          EXITM <OFFSET buffer>
  ENDM
  ; ----------------------------------------------
  sqword$ MACRO sqwordvalue:req
      ;; signed qword
      LOCAL buffer
      .data?
          buffer BYTE 24 dup(?)
      IFNDEF sqwfmt    
      .data    
          sqwfmt BYTE "%I64d", 0
      ENDIF    
      .code
          IFE issize(sqwordvalue, 8)
              echo ------------------------
              echo sqword$ - requires QWORD
              echo ------------------------
              .ERR
          ENDIF            
          mov    buffer[0], 0
          invoke crt_sprintf, ADDR buffer, ADDR sqwfmt, sqwordvalue
          EXITM <OFFSET buffer>
  ENDM
  ; ----------------------------------------------
  xqword$ MACRO xqwordvalue:req
      ;; unsigned hex qword
      LOCAL buffer
      .data?
          buffer BYTE 20 dup(?)
      IFNDEF xqwfmt    
      .data    
          xqwfmt BYTE "%I64X", 0
      ENDIF    
      .code
          IFE issize(xqwordvalue, 8)
              echo ------------------------
              echo xqword$ - requires QWORD
              echo ------------------------
              .ERR
          ENDIF            
          mov    buffer[0], 0
          invoke crt_sprintf, ADDR buffer, ADDR xqwfmt, xqwordvalue
          EXITM <OFFSET buffer>
  ENDM
  ; ----------------------------------------------
  real4$ MACRO r4value:req
      LOCAL buffer, r8value, r4tmp
      .data?
          r4tmp   REAL4 ?
          r8value REAL8 ?
          buffer  BYTE  48 dup(?)
      IFNDEF r8fmt    
      .data
          r8fmt   BYTE "%lf", 0
      ENDIF    
      .code
          IFE issize(r4value, 4)
              echo ------------------------
              echo real4$ - requires REAL4
              echo ------------------------
              .ERR
          ENDIF            
          IF isregister(r4value)
              push   r4value
              pop    r4tmp
              finit
              fld    r4tmp
          ELSE
              finit
              fld    r4value
          ENDIF    
          fstp   r8value
          fwait
          mov    buffer[0], 0
          invoke crt_sprintf, ADDR buffer, ADDR r8fmt, r8value
          EXITM <OFFSET buffer>
  ENDM
  ; ----------------------------------------------
  real8$ MACRO r8value:req
      LOCAL buffer
      .data?
          buffer BYTE 320 dup(?)
      IFNDEF r8fmt    
      .data    
          r8fmt  BYTE "%lf", 0
      ENDIF    
      .code
          IFE issize(r8value, 8)
              echo ------------------------
              echo real8$ - requires REAL8
              echo ------------------------
              .ERR
          ENDIF            
          mov    buffer[0], 0
          invoke crt_sprintf, ADDR buffer, ADDR r8fmt, r8value
          EXITM <OFFSET buffer>
  ENDM
  ; ----------------------------------------------
  real10$ MACRO r10value:req
      LOCAL buffer, r8value
      .data?
          r8value REAL8 ?
          buffer  BYTE  320 dup(?)
      IFNDEF r8fmt    
      .data    
          r8fmt   BYTE "%lf", 0
      ENDIF    
      .code
          IFE issize(r10value, 10)
              echo -------------------------
              echo real10$ - requires REAL10
              echo -------------------------
              .ERR
          ENDIF        
          fld    r10value
          fstp   r8value
          fwait
          mov    buffer[0], 0
          invoke crt_sprintf, ADDR buffer, ADDR r8fmt, r8value
          EXITM <OFFSET buffer>
  ENDM
; ----------------------------------------------