;---------------------------------------
; sscanf conversion macros
;---------------------------------------
a2ub MACRO pStr:req
    LOCAL ub
    .data 
       ub BYTE 0    
    IFNDEF ubfmt   
    .const
        ubfmt BYTE "%hhu",0
    ENDIF  
    .code
    invoke crt_sscanf, pStr, ADDR ubfmt, ADDR ub
    EXITM <OFFSET ub>
ENDM  
;---------------------------------------
a2sb MACRO pStr:req
    LOCAL sb
    .data 
       sb SBYTE 0    
    IFNDEF sbfmt   
    .const
        sbfmt BYTE "%hhd",0
    ENDIF  
    .code
    invoke crt_sscanf, pStr, ADDR sbfmt, ADDR sb
    EXITM <OFFSET sb>
ENDM  
;---------------------------------------
h2ub MACRO pStr:req
    LOCAL ub
    .data 
       ub BYTE 0    
    IFNDEF xbfmt   
    .const
        xbfmt BYTE "%hhX",0
    ENDIF  
    .code
    invoke crt_sscanf, pStr, ADDR xbfmt, ADDR ub
    EXITM <OFFSET ub>
ENDM  
;---------------------------------------
a2uw MACRO pStr:req
    LOCAL uw
    .data 
       uw WORD 0    
    IFNDEF uwfmt   
    .const
        uwfmt BYTE "%hu",0
    ENDIF 
    .code
    invoke crt_sscanf, pStr, ADDR uwfmt, ADDR uw
    EXITM <OFFSET uw>
ENDM   
;---------------------------------------
a2sw MACRO pStr:req
    LOCAL sw
    .data 
       sw SWORD 0    
    IFNDEF swfmt   
    .const
        swfmt BYTE "%hd",0
    ENDIF  
    .code
    invoke crt_sscanf, pStr, ADDR swfmt, ADDR sw
    EXITM <OFFSET sw>
ENDM   
;---------------------------------------
h2uw MACRO pStr:req
    LOCAL uw
    .data 
       uw WORD 0    
    IFNDEF xwfmt   
    .const
        xwfmt BYTE "%hX",0
    ENDIF 
    .code
    invoke crt_sscanf, pStr, ADDR xwfmt, ADDR uw
    EXITM <OFFSET uw>
ENDM   
;---------------------------------------
a2ud MACRO pStr:req
    LOCAL ud
    .data 
        ud DWORD 0    
    IFNDEF udfmt   
    .const
        udfmt BYTE "%u",0
    ENDIF 
    .code
    invoke crt_sscanf, pStr, ADDR udfmt, ADDR ud
    EXITM <OFFSET ud>
ENDM   
;---------------------------------------
a2sd MACRO pStr:req
    LOCAL sd
    .data 
       sd SDWORD 0    
    IFNDEF sdfmt   
    .const
        sdfmt BYTE "%d",0
    ENDIF    
    .code
    invoke crt_sscanf, pStr, ADDR sdfmt, ADDR sd
    EXITM <OFFSET sd>
ENDM   
;---------------------------------------
h2ud MACRO pStr:req
    LOCAL ud
    .data 
        ud DWORD 0    
    IFNDEF xdfmt   
    .const
        xdfmt BYTE "%X",0
    ENDIF 
    .code
    invoke crt_sscanf, pStr, ADDR xdfmt, ADDR ud
    EXITM <OFFSET ud>    
ENDM   
;---------------------------------------
a2uq MACRO pStr:req
    LOCAL uq
    .data 
       align 8
       uq QWORD 0    
    IFNDEF uqfmt   
    .const
        uqfmt BYTE "%I64u",0
    ENDIF   
    .code
    invoke crt_sscanf, pStr, ADDR uqfmt, ADDR uq
    EXITM <OFFSET uq>
ENDM   
;---------------------------------------
a2sq MACRO pStr:req
    LOCAL sq
    .data 
       align 8
       sq QWORD ?    
    IFNDEF sqfmt   
    .const
        sqfmt BYTE "%I64d",0
    ENDIF   
    .code
    invoke crt_sscanf, pStr, ADDR sqfmt, ADDR sq
    EXITM <OFFSET sq>
ENDM   
;-------------------------------------------
h2uq MACRO pStr:req
    LOCAL uq
    .data 
       align 8
       uq QWORD 0    
    IFNDEF xqfmt   
    .const
        xqfmt BYTE "%I64X",0
    ENDIF   
    .code
    invoke crt_sscanf, pStr, ADDR xqfmt, ADDR uq
    EXITM <OFFSET uq>
ENDM   
;---------------------------------------
a2r4 MACRO pStr:req
    LOCAL r4
    .data
      r4 REAL4 0.0
    IFNDEF r4fmt   
    .const
        r4fmt BYTE "%f",0
    ENDIF   
    .code
    invoke crt_sscanf, pStr, ADDR r4fmt, ADDR r4 
    EXITM <OFFSET r4>
ENDM   
;-------------------------------------------
a2r8 MACRO pStr:req
    LOCAL r8
    .data
      align 8
      r8 REAL8 0.0
    IFNDEF r8fmt   
    .const
        r8fmt BYTE "%lf",0
    ENDIF
    .code
    invoke crt_sscanf, pStr, ADDR r8fmt, ADDR r8 
    EXITM <OFFSET r8>
ENDM   
;--------------------------------------------
a2r10 MACRO pStr:req
    LOCAL r8, r10
    .data
       align 16
       r10 REAL10 0.0
       r8  REAL8  0.0
    IFNDEF r8fmt   
    .data
        r8fmt BYTE "%lf",0
    ENDIF    
    .code
    invoke crt_sscanf, pStr, ADDR r8fmt, ADDR r8
    finit
    fld r8
    fstp r10
    EXITM <OFFSET r10>
ENDM
;--------------------------------------------