; 'String to number' conversion macros that 
; use the C Run-Time Library function sscanf.
; Greg Lyon - 2005
;
.586
.MODEL FLAT, stdcall
option casemap:none

include windows.inc

include kernel32.inc
include user32.inc
include masm32.inc
include msvcrt.inc

includelib kernel32.lib
includelib user32.lib
includelib masm32.lib
includelib msvcrt.lib

include c:\masm32\macros\macros.asm 

include sprintf_macros.asm    ; requires the newest sprintf conversion macros
include sscanf_macros.asm

.DATA

align 16
r10temp  REAL10 0.0

szUbMin  BYTE   "0",0
szUbMax  BYTE   "255",0
szSbMin  BYTE  "-128",0
szSbMax  BYTE   "127",0
szUwMin  BYTE   "0",0
szUwMax  BYTE   "65535",0
szSwMin  BYTE  "-32768",0
szSwMax  BYTE   "32767",0
szUdMin  BYTE   "0",0
szUdMax  BYTE   "4294967295",0
szSdMin  BYTE  "-2147483648",0
szSdMax  BYTE   "2147483647",0
szUqMin  BYTE   "0",0
szUqMax  BYTE   "18446744073709551615",0
szSqMin  BYTE  "-9223372036854775808",0
szSqMax  BYTE   "9223372036854775807",0
szR4Min  BYTE  "-1.175494351E-38",0
szR4Max  BYTE   "3.402823466E+38",0
szR8Min  BYTE  "-2.2250738585072014E-308",0
szR8Max  BYTE   "1.7976931348623158E+308",0
szR10Min BYTE  "-2.2250738585072014E-308",0
szR10Max BYTE   "1.7976931348623158E+308",0 
szHexUb  BYTE  "FF", 0
szHexUw  BYTE  "FFFF", 0
szHexUd  BYTE  "FFFFFFFF", 0
szHexUq  BYTE  "FFFFFFFFFFFFFFFF", 0

szPAK    BYTE  10, "Press any key to exit...", 0

szLf     BYTE  10, 0
pszLf    PBYTE szLf

.CODE

start:

    ; decimal string to unsigned byte
    mov edx, a2ub(OFFSET szUbMax)
    mov al, BYTE PTR [edx]
    print ubyte$(al)
    print pszLf 
    mov edx, a2ub(OFFSET szUbMin)
    mov al, BYTE PTR [edx]
    print ubyte$(al)
    print pszLf
    print pszLf

    ; decimal string to signed byte
    mov edx, a2sb(OFFSET szSbMax)
    mov al, SBYTE PTR [edx]
    print sbyte$(al)
    print pszLf
    mov edx, a2sb(OFFSET szSbMin)
    mov al, SBYTE PTR [edx]
    print sbyte$(al)
    print pszLf
    print pszLf
    
    ; hex string to unsigned byte
    mov edx, h2ub(OFFSET szHexUb)
    mov al, BYTE PTR [edx]
    print xbyte$(al)
    print pszLf
    mov edx, h2ub(OFFSET szUbMin)
    mov al, BYTE PTR [edx]
    print xbyte$(al)
    print pszLf
    print pszLf

    ; decimal string to unsigned word
    mov edx, a2uw(OFFSET szUwMax)
    mov ax, WORD PTR [edx]
    print uword$(ax)
    print pszLf    
    mov edx, a2uw(OFFSET szUwMin)
    mov ax, WORD PTR [edx]
    print uword$(ax)
    print pszLf    
    print pszLf
    
    ; decimal string to signed word
    mov edx, a2sw(OFFSET szSwMax)
    mov ax, SWORD PTR [edx]
    print sword$(ax)
    print pszLf   
    mov edx, a2sw(OFFSET szSwMin)
    mov ax, SWORD PTR [edx]
    print sword$(ax)
    print pszLf
    print pszLf
    
    ; hex string to unsigned word
    mov edx, h2uw(OFFSET szHexUw)
    mov ax, WORD PTR [edx]
    print xword$(ax)
    print pszLf    
    mov edx, h2uw(OFFSET szUwMin)
    mov ax, WORD PTR [edx]
    print xword$(ax)
    print pszLf    
    print pszLf
        
    
    ; decimal string to unsigned dword
    mov edx, a2ud(OFFSET szUdMax)
    mov eax, DWORD PTR [edx]
    print udword$(eax)
    print pszLf
    mov edx, a2ud(OFFSET szUdMin)
    mov eax, DWORD PTR [edx]
    print udword$(eax)
    print pszLf    
    print pszLf
    
    ; decimal string to signed dword
    mov edx, a2sd(OFFSET szSdMax)
    mov eax, SDWORD PTR [edx]
    print sdword$(eax)
    print pszLf
    mov edx, a2sd(OFFSET szSdMin)
    mov eax, SDWORD PTR [edx]
    print sdword$(eax)
    print pszLf
    print pszLf
    
    ; hex string to unsigned dword
    mov edx, h2ud(OFFSET szHexUd)
    mov eax, DWORD PTR [edx]
    print xdword$(eax)
    print pszLf
    mov edx, h2ud(OFFSET szUdMin)
    mov eax, DWORD PTR [edx]
    print xdword$(eax)
    print pszLf 
    print pszLf
    
    ; decimal string to unsigned qword
    mov ecx, a2uq(OFFSET szUqMax)
    mov eax, DWORD PTR [ecx+0]
    mov edx, DWORD PTR [ecx+4]
    print uqword$(edx::eax)
    print pszLf
    mov ecx, a2uq(OFFSET szUqMin)
    mov eax, DWORD PTR [ecx+0]
    mov edx, DWORD PTR [ecx+4]
    print uqword$(edx::eax)
    print pszLf
    print pszLf
    
    ; decimal string to signed qword
    mov ecx, a2sq(OFFSET szSqMax)
    mov eax,  DWORD PTR [ecx+0]
    mov edx, SDWORD PTR [ecx+4]
    print sqword$(edx::eax)
    print pszLf
    mov ecx, a2sq(OFFSET szSqMin)
    mov eax,  DWORD PTR [ecx+0]
    mov edx, SDWORD PTR [ecx+4]    
    print sqword$(edx::eax)
    print pszLf
    print pszLf
    
    ; hex string to unsigned qword
    mov ecx, h2uq(OFFSET szHexUq)
    mov eax, DWORD PTR [ecx+0]
    mov edx, DWORD PTR [ecx+4] 
    print xqword$(edx::eax)
    print pszLf
    mov ecx, h2uq(OFFSET szUqMin)
    mov eax, DWORD PTR [ecx+0]
    mov edx, DWORD PTR [ecx+4] 
    print xqword$(edx::eax)
    print pszLf
    print pszLf
    
    ; real4
    mov edx, a2r4(OFFSET szR4Max)
    mov eax, REAL4 PTR [edx]
    print real4$(eax)
    print pszLf
    mov edx, a2r4(OFFSET szR4Min)
    mov eax, REAL4 PTR [edx]
    print real4$(eax)
    print pszLf
    print pszLf
    
    ; real8
    mov ecx, a2r8(OFFSET szR8Max)
    mov eax, DWORD PTR [ecx+0]
    mov edx, DWORD PTR [ecx+4]
    print real8$(edx::eax)
    print pszLf
    mov ecx, a2r8(OFFSET szR8Min)
    mov eax, DWORD PTR [ecx+0]
    mov edx, DWORD PTR [ecx+4]
    print real8$(edx::eax)
    print pszLf
    print pszLf
    
    ; real10
    mov edx, a2r10(OFFSET szR10Max)
    invoke crt_memcpy, ADDR r10temp, edx, 10 
    print real10$(r10temp)
    print pszLf
    mov edx, a2r10(OFFSET szR10Min)
    invoke crt_memcpy, ADDR r10temp, edx, 10
    print real10$(r10temp)
    print pszLf
    
    inkey ADDR szPAK
    
    invoke ExitProcess, 0

end start 
